package ch.epfl.cs108;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

final class FlippedHorizontally implements ASCIImage {
    private final ASCIImage shape;

    public FlippedHorizontally(ASCIImage shape) {
        this.shape = shape;
    }

    @Override
    public int width() {
        return shape.width();
    }

    @Override
    public int height() {
        return shape.height();
    }

    @Override
    public List<String> drawing() {
        List<String> o = shape.drawing();
        List<String> f = new ArrayList<>(o.size());
        for (String l: o)
            f.add(Strings.reverse(l));
        return Collections.unmodifiableList(f);
    }
}
